您的位置:首页 > 其它

线段树(询问、插入)&树状数组POJ2352Starts解题报告

2015-09-01 23:16 435 查看
Stars

Time Limit: 1000MS Memory Limit: 65536K

Total Submissions: 37710 Accepted: 16424

Description

Astronomers often examine star maps where stars are represented by points on a plane and each star has Cartesian coordinates. Let the level of a star be an amount of the stars that are not higher and not to the right of the given star. Astronomers want to know the distribution of the levels of the stars.

For example, look at the map shown on the figure above. Level of the star number 5 is equal to 3 (it’s formed by three stars with a numbers 1, 2 and 4). And the levels of the stars numbered by 2 and 4 are 1. At this map there are only one star of the level 0, two stars of the level 1, one star of the level 2, and one star of the level 3.

You are to write a program that will count the amounts of the stars of each level on a given map.

Input

The first line of the input file contains a number of stars N (1<=N<=15000). The following N lines describe coordinates of stars (two integers X and Y per line separated by a space, 0<=X,Y<=32000). There can be only one star at one point of the plane. Stars are listed in ascending order of Y coordinate. Stars with equal Y coordinates are listed in ascending order of X coordinate.

Output

The output should contain N lines, one number per line. The first line contains amount of stars of the level 0, the second does amount of stars of the level 1 and so on, the last line contains amount of stars of the level N-1.

Sample Input

5

1 1

5 1

7 1

3 3

5 5

Sample Output

1

2

1

1

0

Hint

This problem has huge input data,use scanf() instead of cin to read data to avoid time limit exceed.

Source

Ural Collegiate Programming Contest 1999

由于y坐标是递增的,所以关注x坐标就好。假设当前输入的坐标为(x,y),线段树维护已经输入的所有坐标中,横坐标范围在[0,x]内的星星数sum,sum即为当前点(x,y)的level值。然后将点(x,y)的x值插入线段树,modify函数。

#include <iostream>
#include <stdio.h>
#include <string.h>
using namespace std;
const int maxn=15111,maxm=32111;
int ans[maxn];
struct
{
int L,R;
int sum;
}SegTree[maxm*4];
void makeSegTreeee(int Node,int L,int R)
{
SegTree[Node].L=L; SegTree[Node].R=R; SegTree[Node].sum=0;
if(L==R) return;
int mid=(L+R)/2;
makeSegTreeee(Node*2,L,mid);
makeSegTreeee(Node*2+1,mid+1,R);
}
void modify(int Node,int x)
{
SegTree[Node].sum++;
if(SegTree[Node].L==SegTree[Node].R) return;
int mid=(SegTree[Node].L+SegTree[Node].R)>>1;
if(x<=mid) modify(Node*2,x);
else modify(Node*2+1,x);
}
int query(int Node,int L,int R)
{
if(SegTree[Node].R==R&&SegTree[Node].L==L)//刚好询问的是本区间
return(SegTree[Node].sum);
int mid=(SegTree[Node].L+SegTree[Node].R)/2;
if(R<=mid)
query(Node<<1,L,R);//询问左子树
else if(mid+1<=L)
query(Node<<1|1,L,R);//询问右子树
else
return(query(Node*2,L,mid)+query(Node*2+1,mid+1,R));//询问左右子树
}
int main()
{
freopen("output.txt","w",stdout);
freopen("input.txt","r",stdin);
int n;
while(scanf("%d",&n)!=EOF)
{
makeSegTreeee(1,0,32000);
memset(ans,0,sizeof(ans));
for(int i=1,x,y,tmp_x;i<=n;i++)
{
scanf("%d %d",&x,&y);
tmp_x=query(1,0,x);
ans[tmp_x]++;
modify(1,x);
}
for(int i=0;i<n;i++) printf("%d\n",ans[i]);
}
return 0;
}


以下是树状数组解法:

#include<stdio.h>
#include<string.h>
const int N = 32010;
int sum
, level
;

int lowbit(int x)
{
return x & (-x);
}

int get_sum(int x)
{
int s = 0;
while(x > 0)
{
s += sum[x];
x -= lowbit(x);
}
return s;
}

void insert(int x)
{
while(x < 32005)
{
sum[x]++;
x += lowbit(x);
}
}

int main()
{
int n, x, y, i;
while(~scanf("%d",&n))
{
memset(sum, 0, sizeof(sum));
memset(level, 0, sizeof(level));
for(i = 0; i < n; i++)
{
scanf("%d%d",&x,&y);
level[get_sum(x+1)]++;
insert(x+1); //更新sum[i]的值
}
for(i = 0; i < n; i++)
printf("%d\n",level[i]);
}
return 0;
}
//sum[i]表示x不大于i的点的数目
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  线段树 poj 树状数组